#ifndef _BPQ_BLOCK_PROCESSOR_H_
#define _BPQ_BLOCK_PROCESSOR_H_

#include "BlockProcessor.h"
#include <oasys/util/StringBuffer.h>

namespace dtn {

/**
 * Block processor implementation for the BPQ Extension Block
 */
class BPQBlockProcessor : public BlockProcessor {
public:
    /// Constructor
    BPQBlockProcessor();

    /// @{ Virtual from BlockProcessor

    int consume(Bundle*    bundle,
                BlockInfo* block,
                u_char*    buf,
                size_t     len);

    int generate(const Bundle*  bundle,
                 BlockInfoVec*  xmit_blocks,
                 BlockInfo*     block,
                 const LinkRef& link,
                 bool           last);

    /// @}
};

} // namespace dtn

#endif /* _BPQ_BLOCK_PROCESSOR_H_ */
